import com.rinearn.graph3d.RinearnGraph3D;
import com.rinearn.graph3d.RinearnGraph3DOptionItem;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

/**
 * iq_f[^AIɑ葱āA
 * ȖʃOtAj[V\TvR[hłB
 */
public class Sample4 implements Runnable, WindowListener {
	
	private Thread thread = null; // Aj[Vp̃Xbh
	private RinearnGraph3D graph = null; // Ot
	private volatile boolean continuesLoop = true; // [v̌p/I𐧌䂷
	
	// main\bh(ŏɎs܂)
	public static void main(String[] args) {
		new Sample4();
	}
	
	// EsJn
	public Sample4() {
		
		// OtNăvbgIvVݒiȖʃvbgj
		this.graph = new RinearnGraph3D();
		this.graph.setOptionSelected(RinearnGraph3DOptionItem.POINT, false);
		this.graph.setOptionSelected(RinearnGraph3DOptionItem.MEMBRANE, true);
		
		// `͈͂̐ݒƎ@\̖
		this.graph.setXRange(0.0, 5.0);
		this.graph.setYRange(0.0, 5.0);
		this.graph.setZRange(-1.0, 1.0);
		this.graph.setXAutoRangingEnabled(false);
		this.graph.setYAutoRangingEnabled(false);
		this.graph.setZAutoRangingEnabled(false);
		
		// f[^XVƕ`揈̊֌W񓯊ɂ(A^CAj[Vp)
		//i AԂŉ摜o͂prȂǂł͍sȂR}⌇hj
		this.graph.setAsynchronousPlottingEnabled(true);
		
		// OtƎIsXi[o^AftHg͖
		this.graph.addWindowListener(this);
		this.graph.setAutoDisposingEnabled(false);
		
		// Aj[VXbh𐶐ĎsJn
		this.thread = new Thread(this);
		this.thread.start();
	}
	
	// Aj[VXbh̏
	@Override
	public void run() {
		int n = 80; // bV̊e̋Ԑ
		double[][] x = new double[n+1][n+1]; //e̒_͋Ԑ+1
		double[][] y = new double[n+1][n+1];
		double[][] z = new double[n+1][n+1];
		
		// Aj[V[vicontinuesLooptrue̊Ԍpj
		for(int frame=0; this.continuesLoop; frame++) {
			double t = frame * 0.05; // ϐ
    	
			// Wlf[^̍XV
			for(int i=0; i<=n; i++) {
				for(int j=0; j<=n; j++) {
					x[i][j] = i * (5.0/n);
					y[i][j] = j * (5.0/n);
					z[i][j] = Math.sin(x[i][j]-t) * Math.cos(y[i][j]+t)
							* Math.sin(Math.cos(x[i][j]+y[i][j])-2*t-0.7);
				}
			}
			// Wlf[^Otɓ](񓯊)
			this.graph.setData(x, y, z);
            
			// 50~b~(Ԃ͓K)
			try {
				Thread.sleep(50);
			} catch(InterruptedException e) {
				// 荞ݗȌ
			}
		}
		
		// Aj[V[vIOtj
		this.graph.dispose();
		
		// XbhI[: ɃXbhE\[XcĂȂΎRɎsI
	}
	
	
	//  ȉ̂悤ȃCxg̎ʓ|ȏꍇ́Ał悯΁A
	// this.graph.setAutoExittingEnabled(true); ɂAOt
	// AvP[V̎s𑦏I悤ݒ\łiȂ̏ꍇłjB
	
	// Ot̃EBhEꂽۂɍsCxg
	@Override
	public void windowClosing(WindowEvent e) {
		// Aj[V[vEoAXbhIiʁAsIj
		this.continuesLoop = false;
	}
	
	// ̑̃EBhECxgił͉Ȃj
	@Override
	public void windowDeactivated(WindowEvent e) { }
	@Override
	public void windowActivated(WindowEvent e) { }
	@Override
	public void windowDeiconified(WindowEvent e) { }
	@Override
	public void windowIconified(WindowEvent e) { }
	@Override
	public void windowOpened(WindowEvent e) { }
	@Override
	public void windowClosed(WindowEvent e) { }

}
